/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH PLAYER/CONVERTER SOURCE CODE. *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  $Id: cmdparse.c,v 1.3 1997/12/27 05:39:59 ogg Exp $
  $Date: 1997/12/27 05:39:59 $
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty, wrong Mike
  function: Parse ogg command line args 

 ********************************************************************/

#include "oggapp.h"
#include "appio.h"
#include "header.h"

#ifndef lint
static char rcs_id[] = "$Id: cmdparse.c,v 1.3 1997/12/27 05:39:59 ogg Exp $";
#endif

/* command line values and globals */

extern const char OPTFORMAT[];

int hasoption(char c){
  int i=0;
  while(OPTFORMAT[i]!='*'){
    if(OPTFORMAT[i]==c)
      if(OPTFORMAT[i+1]=='!')
	if(OPTFORMAT[i+2]==':')
	  return(1);
	else
	  return(0);
      else
	if(OPTFORMAT[i+1]==':')
	  return(1);
	else
	  return(0);
    i++;
  }
  return(0);
}

int hasmulti(char c){
  int i=0;
  while(OPTFORMAT[i]!='*'){
    if(OPTFORMAT[i]==c)
      if(OPTFORMAT[i+1]=='!')
	return(1);
      else
	return(0);
    i++;
  }
  return(0);
}

/* This finds a lone (non argument) string; '1' is the first string
   after the actual executable name */
char *stringoption(int argc,char *argv[],int pos){
  int i;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(argv[i][1]=='\0' || !strcmp(argv[i-1],"--"))pos--;
    }else
      if(argv[i-1][0]=='-'){
	int j,flag=0;
	for(j=1;j<(int)strlen(argv[i-1]);j++)
	  if(hasmulti(argv[i-1][j])){
	    flag=-1;
	    break;
	  }
	if(!flag && !hasoption(argv[i-1][strlen(argv[i-1])-1]))
	  pos--;
	/*	if(flag && hasoption(argv[i-1][j]))i++;*/
      }else
	pos--;
    if(pos==0)return(argv[i]);
  }
  return(NULL);
}

int checkoption(int argc,char *argv[],int c){
  int i;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(strcmp(argv[i-1],"--")){
	int j;
	for(j=1;j<(int)strlen(argv[i]);j++){
	  if(hasmulti(argv[i][j])&&argv[i][j]!=c){
	    if(hasoption(argv[i][j]))i++;
	    break;
	  }
	  if(hasoption(argv[i][j]) && argv[i][j]!=c)break;
	  if(argv[i][j]==c)return(-1);
	}
      }
    }
  }
  return(0);
}

int optionnum(int argc,char *argv[],int pos,long *num,char **add,char **s){
  int i;
  *add=NULL;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(strcmp(argv[i-1],"--")){
	int j;
	for(j=1;j<(int)strlen(argv[i]);j++){
	  pos--;
	  if(pos<0){
	    if(hasmulti(argv[i][j])){
	      *add=argv[i]+j+1;
	      
	      *s=argv[i+1];
	      if(*s)
		*num=atoi(*s);
	      else
		*num=0;

	    }else
	      if(argv[i][j+1]=='\0'){
		*s=argv[i+1];
		if(*s)
		  *num=atoi(*s);
		else
		  *num=0;
	      }else{
		*s=argv[i]+j+1;
		*num=atoi(*s);
	      }
	    return(argv[i][j]);
	  }
	  if(hasmulti(argv[i][j])){
	    if(hasoption(argv[i][j]))i++;
	    break;
	  }
	  if(hasoption(argv[i][j]))break;
	}
      }
    }
  }
  return(0);
}

