/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH PLAYER/CONVERTER SOURCE CODE. *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1997             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  $Id: common.c,v 1.3 1997/12/27 05:39:59 ogg Exp $
  $Date: 1997/12/27 05:39:59 $
  function: Application common utilities
  author: Wrong Mike <mwhitson@mit.edu>
  modifications by: Wrong Mike

 ********************************************************************/

#ifndef lint
static char rcs_id[] = "$Id: common.c,v 1.3 1997/12/27 05:39:59 ogg Exp $";
#endif

/* Utility functions common to ogg applications */

#include "oggapp.h"

#ifdef HAVE_SIGACTION
#include <signal.h>
typedef void    Sigfunc(int);   /* for signal handlers */
#if     defined(SIG_IGN) && !defined(SIG_ERR)
#define SIG_ERR ((Sigfunc *)-1)
#endif

/* Reliable signal()s (Stevens: Advanced UNIX PRG, pp. 298) */

Sigfunc *signal(int signo, Sigfunc *func){
  struct sigaction act, oact;

  act.sa_handler = func;
  sigemptyset(&act.sa_mask);
  act.sa_flags = 0;
  if (signo == SIGALRM) {
#ifdef SA_INTERRUPT
    act.sa_flags |= SA_INTERRUPT;     /* SunOS */
#endif
  }
  else {
#ifdef SA_RESTART
    act.sa_flags |= SA_RESTART;       /* SVR4, 4.3+BSD */
#endif
  }
  if (sigaction(signo, &act, &oact) < 0)
    return SIG_ERR;
  return oact.sa_handler;
}

#endif      /* HAVE_SIGACTION */
