/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  $Id: oggapp.h,v 1.4 1998/01/20 04:55:18 ogg Exp $
  $Date: 1998/01/20 04:55:18 $
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty, Wrong Mike
  function: Top level common include file for ogg player apps

 ********************************************************************/

#ifndef _OGGAPP_H
#define _OGGAPP_H

#include <config.h>

#include <unistd.h>
#if !defined(__vax__) && !defined(ISC)
#  include <stdlib.h>
#endif
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>

#ifdef __BOUNDS_CHECKING_ON
/* Insert your bounds gcc include dir here */
#  include</mit/bounds/src/gcc-2.7.2/bounds/run-includes/unchecked.h>
#define DEBUG_FEATURES 1
#else
#define BOUNDS_CHECKING_ON
#define BOUNDS_CHECKING_OFF
#endif

#ifdef OGG_DEBUG
#define debug_msg fprintf
#else
#define debug_msg
#endif

/* Internal app state constants */
#define OGG_INPUT_OGG 0
#define OGG_INPUT_RAW 1
#define OGG_INPUT_WAVE 2
#define OGG_INPUT_AIFF 3

#define OGG_OUTPUT_PLAYBACK -1
#define OGG_OUTPUT_OGG OGG_INPUT_OGG
#define OGG_OUTPUT_RAW OGG_INPUT_RAW
#define OGG_OUTPUT_WAVE OGG_INPUT_WAVE
#define OGG_OUTPUT_AIFF OGG_INPUT_AIFF

#define OGG_ACTION_ENCODE 0
#define OGG_ACTION_DECODE 1
#define OGG_ACTION_PLAYBACK 2

#include <libogg.h>

#endif  /* _OGGAPP_H */
